/*
Scrivere un programma per la gestione dei bollettini postali. Ogni  bollettino  caratterizzato dalle seguenti informazioni: numero conto corrente postale, importo, codice operazione (esempio CTA2027), esecutore, data pagamento. 
I bollettini sono organizzati in memoria come un vettore con 60 elementi.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Lettura da file e copia nel vettore dei bollettini relativi a un certo giorno ( chiedere la data);
2) Inserimento di un nuovo bollettino;
3) Cancellazione di un bollettino  (chiedere il codice operazione);
4) Visualizzazione dei bollettini di un certo giorno (chiedere la data);
5) Salvataggio su file dei bollettini.
*/

# include <stdio.h>
# include <string.h>


struct bollettino{

       int  ncontocorrente;
       float importo;
       char codice[20];
       char esecutore[30];
       char data[11];       
};


void inserimento(struct bollettino *V,int *pn)

{struct bollettino b;

  if(*pn<60) /*Vettore non pieno*/
  
    {printf("Num. conto corrente:");
     scanf("%d",& b.ncontocorrente);
     printf("Importo:");
     scanf("%f",& b.importo);
     printf("Codice:");
     scanf("%s",b.codice);
     printf("Nominativo esecutore:");
     scanf("%s",b.esecutore);
     printf("Data:");
     scanf("%s",b.data); 
     V[*pn]=b;
     (*pn)++;
     }
   else printf("Vettore pieno\n");
}


void cancellazione(struct bollettino *V,int *pn)

{int i,p;
 char codice[20];  

  printf("Codice:");
  scanf("%s",codice);
  
  /*Ricerca*/
  
  for(p=0;p<*pn;p++)
    
     if(strcmp(V[p].codice,codice)==0)
          break;
  
  if(p<*pn) /*Trovato*/
  
       { /*Cancellazione*/
     
        for(i=p;i<*pn-1;i++) 
         V[i]=V[i+1] ;
     
        (*pn)--;       
       }
  else printf("Elemento non trovato\n");
}


void visualizzazione(struct bollettino *V,int n)

{int i;
 char data[11];
 
 printf("Data:");
 scanf("%s",data);
 
 for(i=0;i<n;i++)
   if(strcmp(V[i].data,data)==0)
      { 
        printf("Num. conto corrente: %d\n",V[i].ncontocorrente);
        printf("Importo: %f\n",V[i].importo);
        printf("Codice: %s\n",V[i].codice);
        printf("Nominativo esecutore: %s\n",V[i].esecutore);
       
      }
}
        
void salvataggio(struct bollettino *V,int n)

{FILE*pf;
 int i;
 
 pf=fopen("bollettini.ges","wb");
  
  if(pf)
    
       {for(i=0;i<n;i++)
           fwrite(&V[i],sizeof(struct bollettino),1,pf);
      
        fclose(pf);
       }
  else printf("Errore in scrittura/n");
}


void lettura(struct bollettino *V,int *pn)

{FILE*pf;
 int i;
 char data[11];
 struct bollettino b;
 
 i=0;
 printf("Data:");
 scanf("%s",data);
 
 pf=fopen("bollettini.ges","rb");
  
  if(pf)
     
       {  while(i<60 && fread(&b,sizeof(struct bollettino),1,pf)>0)
            if(strcmp(b.data,data)==0)
              {V[i]=b;
               i++;
              }
               
          fclose(pf);
       }
  else printf("Errore in lettura/n");
       *pn=i;
}
       
main()
{

  struct bollettino B[60];
  int n;
  int scelta;

  n=0;
  
  do{
      printf("Scegli tra\n");
      printf("1)Lettura\n2)Inserimento\n");
      printf("3)Cancellazione\n4)Visualizzazione\n");
      printf("5)Salvataggio\n");
      printf("0)Fine\n");
  
      scanf("%d",& scelta);
   
      switch(scelta){
   
        case 1: lettura(B,&n);
                break;  
        case 2: inserimento(B,&n);
                break;
        case 3: cancellazione(B,&n);
                break;
        case 4: visualizzazione(B,n);
                break;
        case 5: salvataggio(B,n);
                break;    
        default:;
     
     }
  }while(scelta!=0);
}                                                                   
                                             
    
    
            
